Index: src/saveload/company_sl.cpp
===================================================================
--- src/saveload/company_sl.cpp	(revision 17973)
+++ src/saveload/company_sl.cpp	(working copy)
@@ -123,6 +123,8 @@
 
 	    SLE_VAR(Company, num_valid_stat_ent,    SLE_UINT8),
 
+	SLE_CONDVAR(Company, sharing_delay,         SLE_UINT8,               SL_IS, SL_MAX_VERSION),
+
 	    SLE_VAR(Company, quarters_of_bankruptcy,SLE_UINT8),
 	SLE_CONDVAR(Company, bankrupt_asked,        SLE_FILE_U8  | SLE_VAR_U16,  0, 103),
 	SLE_CONDVAR(Company, bankrupt_asked,        SLE_UINT16,                104, SL_MAX_VERSION),
@@ -132,7 +134,8 @@
 
 	/* yearly expenses was changed to 64-bit in savegame version 2. */
 	SLE_CONDARR(Company, yearly_expenses,       SLE_FILE_I32 | SLE_VAR_I64, 3 * 13, 0, 1),
-	SLE_CONDARR(Company, yearly_expenses,       SLE_INT64, 3 * 13,                  2, SL_MAX_VERSION),
+	SLE_CONDARR(Company, yearly_expenses,       SLE_INT64, 3 * 13,                  2, SL_IS - 1),
+	SLE_CONDARR(Company, yearly_expenses,       SLE_INT64, 3 * 15,              SL_IS, SL_MAX_VERSION),
 
 	SLE_CONDVAR(Company, is_ai,                 SLE_BOOL,                    2, SL_MAX_VERSION),
 	SLE_CONDNULL(1, 107, 111), ///< is_noai
@@ -226,6 +229,13 @@
 	SLE_END()
 };
 
+static const SaveLoad _company_sharing_desc[] = {
+	SLE_CONDARR(CompanySharingSettingsEntry,            option,  SLE_UINT8, 4, SL_IS, SL_MAX_VERSION),
+	SLE_CONDARR(CompanySharingSettingsEntry,               fee, SLE_UINT16, 4, SL_IS, SL_MAX_VERSION),
+	SLE_CONDVAR(CompanySharingSettingsEntry, allowed_companies, SLE_UINT16,    SL_IS, SL_MAX_VERSION),
+	SLE_END()
+};
+
 static void SaveLoad_PLYR(Company *c)
 {
 	int i;
@@ -243,6 +253,10 @@
 		}
 	}
 
+	/* Write sharing settings */
+	SlObject(&c->sharing_current, _company_sharing_desc);
+	SlObject(&c->sharing_future,  _company_sharing_desc);
+
 	/* Write economy */
 	SlObject(&c->cur_economy, _company_economy_desc);
 
Index: src/saveload/afterload.cpp
===================================================================
--- src/saveload/afterload.cpp	(revision 17973)
+++ src/saveload/afterload.cpp	(working copy)
@@ -1946,6 +1946,33 @@
 			if (IsTileType(d->xy, MP_WATER)) _m[GetOtherShipDepotTile(d->xy)].m2 = d->index;
 		}
 	}
+	
+	if (CheckSavegameVersion(SL_IS)) {
+		/* Set the sharing settings to the standard values (no sharing)
+		 * as we do not want these to be copied from the newgame settings. */
+		_settings_game.sharing.sharing_mode         = SHARING_NONE;
+		_settings_game.sharing.new_individual_delay = 12;
+		_settings_game.sharing.rail_sharing         = 0;
+		_settings_game.sharing.road_sharing         = false;
+		_settings_game.sharing.water_sharing        = false;
+		_settings_game.sharing.air_sharing          = false;
+		_settings_game.sharing.rail_fee             = 100;
+		_settings_game.sharing.road_fee             = 100;
+		_settings_game.sharing.water_fee            = 100;
+		_settings_game.sharing.air_fee              = 100;
+	
+		Company *c;
+		FOR_ALL_COMPANIES(c) {
+			/* yearly_expenses has 3*15 entries now, saveload code gave us 3*13.
+			 * Move the old data to the right place in the new array and clear the new data.
+			 * The move has to be done in reverse order (first 2, then 1). */
+			MemMoveT(&c->yearly_expenses[2][0], &c->yearly_expenses[1][11], 13);
+			MemMoveT(&c->yearly_expenses[1][0], &c->yearly_expenses[0][13], 13);
+			/* Clear the old location of just-moved data, so sharing income/expenses is set to 0 */
+			MemSetT(&c->yearly_expenses[0][13], 0, 2);
+			MemSetT(&c->yearly_expenses[1][13], 0, 2);
+		}
+	}
 
 	AfterLoadLabelMaps();
 
Index: src/saveload/saveload.h
===================================================================
--- src/saveload/saveload.h	(revision 17973)
+++ src/saveload/saveload.h	(working copy)
@@ -80,6 +80,7 @@
 };
 
 #define SL_MAX_VERSION 255
+#define SL_IS 128
 
 enum {
 	INC_VEHICLE_COMMON = 0,
Index: src/yapf/yapf_costrail.hpp
===================================================================
--- src/yapf/yapf_costrail.hpp	(revision 17973)
+++ src/yapf/yapf_costrail.hpp	(working copy)
@@ -34,6 +34,7 @@
 		Trackdir    td;
 		TileType    tile_type;
 		RailType    rail_type;
+		Owner       owner;
 
 		TILE()
 		{
@@ -41,6 +42,7 @@
 			td = INVALID_TRACKDIR;
 			tile_type = MP_VOID;
 			rail_type = INVALID_RAILTYPE;
+			owner = INVALID_OWNER;
 		}
 
 		TILE(TileIndex tile, Trackdir td)
@@ -49,6 +51,7 @@
 			this->td = td;
 			this->tile_type = GetTileType(tile);
 			this->rail_type = GetTileRailType(tile);
+			this->owner = GetTileOwner(tile);
 		}
 
 		TILE(const TILE &src)
@@ -57,6 +60,7 @@
 			td = src.td;
 			tile_type = src.tile_type;
 			rail_type = src.rail_type;
+			owner = src.owner;
 		}
 	};
 
@@ -450,10 +454,15 @@
 			if (!tf_local.Follow(cur.tile, cur.td)) {
 				assert(tf_local.m_err != TrackFollower::EC_NONE);
 				/* Can't move to the next tile (EOL?). */
-				if (tf_local.m_err == TrackFollower::EC_RAIL_TYPE) {
-					end_segment_reason |= ESRB_RAIL_TYPE;
-				} else {
-					end_segment_reason |= ESRB_DEAD_END;
+				switch (tf_local.m_err) {
+					case TrackFollower::EC_RAIL_TYPE:
+						end_segment_reason |= ESRB_RAIL_TYPE;
+						break;
+					case TrackFollower::EC_OWNER:
+						end_segment_reason |= ESRB_OWNER;
+						break;
+					default:
+						end_segment_reason |= ESRB_DEAD_END;
 				}
 
 				if (TrackFollower::DoTrackMasking() && !HasOnewaySignalBlockingTrackdir(cur.tile, cur.td)) {
@@ -484,6 +493,13 @@
 				break;
 			}
 
+			/* Check the next tile for the owner. */
+			if (next.owner != cur.owner) {
+				/* Segment must consist from tiles with the same owner. */
+				end_segment_reason |= ESRB_OWNER;
+				break;
+			}
+
 			/* Avoid infinite looping. */
 			if (next.tile == n.m_key.m_tile && next.td == n.m_key.m_td) {
 				end_segment_reason |= ESRB_INFINITE_LOOP;
Index: src/yapf/yapf_node_rail.hpp
===================================================================
--- src/yapf/yapf_node_rail.hpp	(revision 17973)
+++ src/yapf/yapf_node_rail.hpp	(working copy)
@@ -66,6 +66,7 @@
 	/* The following reasons can be saved into cached segment */
 	ESR_DEAD_END = 0,      ///< track ends here
 	ESR_RAIL_TYPE,         ///< the next tile has a different rail type than our tiles
+	ESR_OWNER,             ///< the next tile has a different owner than our tiles
 	ESR_INFINITE_LOOP,     ///< infinite loop detected
 	ESR_SEGMENT_TOO_LONG,  ///< the segment is too long (possible infinite loop)
 	ESR_CHOICE_FOLLOWS,    ///< the next tile contains a choice (the track splits to more than one segments)
@@ -90,6 +91,7 @@
 
 	ESRB_DEAD_END          = 1 << ESR_DEAD_END,
 	ESRB_RAIL_TYPE         = 1 << ESR_RAIL_TYPE,
+	ESRB_OWNER             = 1 << ESR_OWNER,
 	ESRB_INFINITE_LOOP     = 1 << ESR_INFINITE_LOOP,
 	ESRB_SEGMENT_TOO_LONG  = 1 << ESR_SEGMENT_TOO_LONG,
 	ESRB_CHOICE_FOLLOWS    = 1 << ESR_CHOICE_FOLLOWS,
@@ -109,7 +111,7 @@
 	ESRB_POSSIBLE_TARGET = ESRB_DEPOT | ESRB_WAYPOINT | ESRB_STATION | ESRB_SAFE_TILE,
 
 	/* What reasons can be stored back into cached segment. */
-	ESRB_CACHED_MASK = ESRB_DEAD_END | ESRB_RAIL_TYPE | ESRB_INFINITE_LOOP | ESRB_SEGMENT_TOO_LONG | ESRB_CHOICE_FOLLOWS | ESRB_DEPOT | ESRB_WAYPOINT | ESRB_STATION | ESRB_SAFE_TILE,
+	ESRB_CACHED_MASK = ESRB_DEAD_END | ESRB_RAIL_TYPE | ESRB_OWNER | ESRB_INFINITE_LOOP | ESRB_SEGMENT_TOO_LONG | ESRB_CHOICE_FOLLOWS | ESRB_DEPOT | ESRB_WAYPOINT | ESRB_STATION | ESRB_SAFE_TILE,
 
 	/* Reasons to abort pathfinding in this direction. */
 	ESRB_ABORT_PF_MASK = ESRB_DEAD_END | ESRB_PATH_TOO_LONG | ESRB_INFINITE_LOOP | ESRB_FIRST_TWO_WAY_RED,
@@ -120,7 +122,7 @@
 inline CStrA ValueStr(EndSegmentReasonBits bits)
 {
 	static const char * const end_segment_reason_names[] = {
-		"DEAD_END", "RAIL_TYPE", "INFINITE_LOOP", "SEGMENT_TOO_LONG", "CHOICE_FOLLOWS",
+		"DEAD_END", "RAIL_TYPE", "OWNER", "INFINITE_LOOP", "SEGMENT_TOO_LONG", "CHOICE_FOLLOWS",
 		"DEPOT", "WAYPOINT", "STATION", "SAFE_TILE",
 		"PATH_TOO_LONG", "FIRST_TWO_WAY_RED", "LOOK_AHEAD_END", "TARGET_REACHED"
 	};
Index: src/yapf/follow_track.hpp
===================================================================
--- src/yapf/follow_track.hpp	(revision 17973)
+++ src/yapf/follow_track.hpp	(working copy)
@@ -16,6 +16,7 @@
 #include "../depot_map.h"
 #include "../roadveh.h"
 #include "../train.h"
+#include "../infrastructure_func.h"
 
 /** Track follower helper template class (can serve pathfinders and vehicle
  *  controllers). See 6 different typedefs below for 3 different transport
@@ -62,12 +63,12 @@
 	{
 		assert(!IsRailTT() || (v != NULL && v->type == VEH_TRAIN));
 		m_veh = v;
-		Init(v != NULL ? v->owner : INVALID_OWNER, IsRailTT() && railtype_override == INVALID_RAILTYPES ? Train::From(v)->compatible_railtypes : railtype_override, pPerf);
+		Init(v != NULL ? v->owner : INVALID_OWNER, (IsRailTT() && railtype_override == INVALID_RAILTYPES && v != NULL) ? Train::From(v)->compatible_railtypes : railtype_override, pPerf);
 	}
 
 	FORCEINLINE void Init(Owner o, RailTypes railtype_override, CPerformanceTimer *pPerf)
 	{
-		assert((!IsRoadTT() || m_veh != NULL) && (!IsRailTT() || railtype_override != INVALID_RAILTYPES));
+		assert(!IsRoadTT() || m_veh != NULL);
 		m_veh_owner = o;
 		m_pPerf = pPerf;
 		/* don't worry, all is inlined so compiler should remove unnecessary initializations */
@@ -272,6 +273,7 @@
 	/** return true if we can enter m_new_tile from m_exitdir */
 	FORCEINLINE bool CanEnterNewTile()
 	{
+		bool ignore_owner = (m_veh_owner == INVALID_OWNER);
 		if (IsRoadTT() && IsStandardRoadStopTile(m_new_tile)) {
 			/* road stop can be entered from one direction only unless it's a drive-through stop */
 			DiagDirection exitdir = GetRoadStopDir(m_new_tile);
@@ -279,6 +281,11 @@
 				m_err = EC_NO_WAY;
 				return false;
 			}
+			/* road stops shouldn't be entered unless allowed to */
+			if (!(ignore_owner || IsStationUsageAllowed(m_new_tile, m_veh_owner, VEH_ROAD))) {
+				m_err = EC_OWNER;
+				return false;
+			}
 		}
 
 		/* single tram bits can only be entered from one direction */
@@ -297,8 +304,8 @@
 				m_err = EC_NO_WAY;
 				return false;
 			}
-			/* don't try to enter other company's depots */
-			if (GetTileOwner(m_new_tile) != m_veh_owner) {
+			/* don't try to enter other companies' depots, unless allowed to */
+			if (!(ignore_owner || IsDepotUsageAllowed(m_new_tile, m_veh_owner, VEH_ROAD))) {
 				m_err = EC_OWNER;
 				return false;
 			}
@@ -309,18 +316,23 @@
 				m_err = EC_NO_WAY;
 				return false;
 			}
+			if (!(ignore_owner || IsDepotUsageAllowed(m_new_tile, m_veh_owner, VEH_TRAIN))) {
+				m_err = EC_OWNER;
+				return false;
+			}
 		}
 
-		/* rail transport is possible only on tiles with the same owner as vehicle */
-		if (IsRailTT() && GetTileOwner(m_new_tile) != m_veh_owner) {
+		/* rail transport is possible only on tiles where the vehicle is allowed */
+		if (IsRailTT() && !(ignore_owner || IsRailwayTileUsageAllowed(m_new_tile, m_veh_owner))) {
 			/* different owner */
-			m_err = EC_NO_WAY;
+			m_err = EC_OWNER;
 			return false;
 		}
 
 		/* rail transport is possible only on compatible rail types */
 		if (IsRailTT()) {
 			RailType rail_type = GetTileRailType(m_new_tile);
+			/* If INVALID_RAILTYPES is specified, all bits are set and this test is always passed */
 			if (!HasBit(m_railtypes, rail_type)) {
 				/* incompatible rail type */
 				m_err = EC_RAIL_TYPE;
Index: src/roadveh_cmd.cpp
===================================================================
--- src/roadveh_cmd.cpp	(revision 17973)
+++ src/roadveh_cmd.cpp	(working copy)
@@ -37,6 +37,7 @@
 #include "roadstop_base.h"
 #include "cargotype.h"
 #include "newgrf_cargo.h"
+#include "infrastructure_func.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -200,7 +201,7 @@
 	/* The ai_new queries the vehicle cost before building the route,
 	 * so we must check against cheaters no sooner than now. --pasky */
 	if (!IsRoadDepotTile(tile)) return CMD_ERROR;
-	if (!IsTileOwner(tile, _current_company)) return CMD_ERROR;
+	if (!AreDepotOperationsAllowed(tile, _current_company, VEH_ROAD)) return CMD_ERROR;
 
 	if (HasTileRoadType(tile, ROADTYPE_TRAM) != HasBit(e->info.misc_flags, EF_ROAD_TRAM)) return_cmd_error(STR_ERROR_DEPOT_WRONG_DEPOT_TYPE);
 
@@ -379,7 +380,7 @@
 	tile += TileOffsByDiagDir(_road_pf_directions[trackdir]);
 
 	if (IsRoadDepotTile(tile) &&
-			IsTileOwner(tile, rfdd->owner) &&
+			IsDepotUsageAllowed(tile, rfdd->owner, VEH_ROAD) &&
 			length < rfdd->best_length) {
 		rfdd->best_length = length;
 		rfdd->tile = tile;
@@ -476,7 +477,7 @@
 CommandCost CmdTurnRoadVeh(TileIndex tile, DoCommandFlag flags, uint32 p1, uint32 p2, const char *text)
 {
 	RoadVehicle *v = RoadVehicle::GetIfValid(p1);
-	if (v == NULL || !CheckOwnership(v->owner)) return CMD_ERROR;
+	if (v == NULL || !IsVehicleControlAllowed(v)) return CMD_ERROR;
 
 	if ((v->vehstatus & VS_STOPPED) ||
 			(v->vehstatus & VS_CRASHED) ||
@@ -1040,14 +1041,14 @@
 	TrackdirBits trackdirs = TrackStatusToTrackdirBits(ts);
 
 	if (IsTileType(tile, MP_ROAD)) {
-		if (IsRoadDepot(tile) && (!IsTileOwner(tile, v->owner) || GetRoadDepotDirection(tile) == enterdir || (GetRoadTypes(tile) & v->compatible_roadtypes) == 0)) {
+		if (IsRoadDepot(tile) && (!IsDepotUsageAllowed(tile, v) || GetRoadDepotDirection(tile) == enterdir || (GetRoadTypes(tile) & v->compatible_roadtypes) == 0)) {
 			/* Road depot owned by another company or with the wrong orientation */
 			trackdirs = TRACKDIR_BIT_NONE;
 		}
 	} else if (IsTileType(tile, MP_STATION) && IsStandardRoadStopTile(tile)) {
 		/* Standard road stop (drive-through stops are treated as normal road) */
 
-		if (!IsTileOwner(tile, v->owner) || GetRoadStopDir(tile) == enterdir || v->HasArticulatedPart()) {
+		if (!IsStationUsageAllowed(tile, v) || GetRoadStopDir(tile) == enterdir || v->HasArticulatedPart()) {
 			/* different station owner or wrong orientation or the vehicle has articulated parts */
 			trackdirs = TRACKDIR_BIT_NONE;
 		} else {
@@ -1651,7 +1652,7 @@
 			_road_veh_data_1[v->state - RVSB_IN_ROAD_STOP + (_settings_game.vehicle.road_side << RVS_DRIVE_SIDE)] == v->frame) ||
 			(IsInsideMM(v->state, RVSB_IN_DT_ROAD_STOP, RVSB_IN_DT_ROAD_STOP_END) &&
 			v->current_order.ShouldStopAtStation(v, GetStationIndex(v->tile)) &&
-			v->owner == GetTileOwner(v->tile) &&
+			IsStationUsageAllowed(v->tile, v) &&
 			GetRoadStopType(v->tile) == (IsCargoInClass(v->cargo_type, CC_PASSENGERS) ? ROADSTOP_BUS : ROADSTOP_TRUCK) &&
 			v->frame == RVC_DRIVE_THROUGH_STOP_FRAME))) {
 
Index: src/economy_type.h
===================================================================
--- src/economy_type.h	(revision 17973)
+++ src/economy_type.h	(working copy)
@@ -129,6 +129,8 @@
 	EXPENSES_SHIP_INC,
 	EXPENSES_LOAN_INT,
 	EXPENSES_OTHER,
+	EXPENSES_SHARED_RUN,
+	EXPENSES_SHARED_INC,
 	EXPENSES_END,
 	INVALID_EXPENSES      = 0xFF,
 };
Index: src/pbs.cpp
===================================================================
--- src/pbs.cpp	(revision 17973)
+++ src/pbs.cpp	(working copy)
@@ -242,7 +242,7 @@
 	if (v->type != VEH_TRAIN || (v->vehstatus & VS_CRASHED)) return NULL;
 
 	Train *t = Train::From(v);
-	if (HasBit((TrackBits)t->track, TrackdirToTrack(info->res.trackdir))) {
+	if (HasBit((TrackBits)t->track, TrackdirToTrack(info->res.trackdir)) || t->track == TRACK_BIT_WORMHOLE) {
 		t = t->First();
 
 		/* ALWAYS return the lowest ID (anti-desync!) */
@@ -277,6 +277,40 @@
 }
 
 /**
+ * Find a train on a reservation in a single direction.
+ * @param tile The reserved tile.
+ * @param trackdir The reserved trackdir to start searching.
+ * @param owner The owner of the vehicle. If no owner is known yet, specify INVALID_OWNER.
+ * @param rts The railtypes the vehicle can use. If not known yet, specify INVALID_RAILTYPES.
+ * @return The vehicle this reservation (possibly) belongs to.
+ */
+static Train *FindTrainForReservationDir(TileIndex tile, Trackdir trackdir, Owner owner, RailTypes rts)
+{
+	FindTrainOnTrackInfo ftoti;
+	/* Ignore one-way signals, as we might be searching the wrong way */
+	ftoti.res = FollowReservation(owner, rts, tile, trackdir, true);
+
+	FindVehicleOnPos(ftoti.res.tile, &ftoti, FindTrainOnTrackEnum);
+	if (ftoti.best != NULL) return ftoti.best;
+
+	/* Special case for stations: check the whole platform for a vehicle. */
+	if (HasStationTileRail(ftoti.res.tile)) {
+		TileIndexDiff diff = TileOffsByDiagDir(TrackdirToExitdir(ReverseTrackdir(ftoti.res.trackdir)));
+		for (TileIndex st_tile = ftoti.res.tile + diff; IsCompatibleTrainStationTile(st_tile, ftoti.res.tile); st_tile += diff) {
+			FindVehicleOnPos(st_tile, &ftoti, FindTrainOnTrackEnum);
+			if (ftoti.best != NULL) return ftoti.best;
+		}
+	}
+
+	/* Special case for bridges/tunnels: check the other end as well. */
+	if (IsTileType(ftoti.res.tile, MP_TUNNELBRIDGE)) {
+		FindVehicleOnPos(GetOtherTunnelBridgeEnd(ftoti.res.tile), &ftoti, FindTrainOnTrackEnum);
+		if (ftoti.best != NULL) return ftoti.best;
+	}
+	return NULL;
+}
+
+/**
  * Find the train which has reserved a specific path.
  *
  * @param tile A tile on the path.
@@ -288,32 +322,23 @@
 	assert(HasReservedTracks(tile, TrackToTrackBits(track)));
 	Trackdir  trackdir = TrackToTrackdir(track);
 
-	RailTypes rts = GetRailTypeInfo(GetTileRailType(tile))->compatible_railtypes;
-
 	/* Follow the path from tile to both ends, one of the end tiles should
-	 * have a train on it. We need FollowReservation to ignore one-way signals
-	 * here, as one of the two search directions will be the "wrong" way. */
+	 * have a train on it. Since we don't know the vehicle yet,
+	 * we don't know which tiles it can access with regards to ownership and infrastructure sharing,
+	 * nor do we know which rail types it is compatible with.
+	 * Therefore we first do a test run without ownership or railtype checks.
+	 * If this yields a vehicle, we test again using the now-known owner and railtype info.
+	 * If this still yields a vehicle, we return it as it is the correct one.
+	 */
 	for (int i = 0; i < 2; ++i, trackdir = ReverseTrackdir(trackdir)) {
-		FindTrainOnTrackInfo ftoti;
-		ftoti.res = FollowReservation(GetTileOwner(tile), rts, tile, trackdir, true);
-
-		FindVehicleOnPos(ftoti.res.tile, &ftoti, FindTrainOnTrackEnum);
-		if (ftoti.best != NULL) return ftoti.best;
-
-		/* Special case for stations: check the whole platform for a vehicle. */
-		if (IsRailStationTile(ftoti.res.tile)) {
-			TileIndexDiff diff = TileOffsByDiagDir(TrackdirToExitdir(ReverseTrackdir(ftoti.res.trackdir)));
-			for (TileIndex st_tile = ftoti.res.tile + diff; IsCompatibleTrainStationTile(st_tile, ftoti.res.tile); st_tile += diff) {
-				FindVehicleOnPos(st_tile, &ftoti, FindTrainOnTrackEnum);
-				if (ftoti.best != NULL) return ftoti.best;
-			}
+		Train *t = FindTrainForReservationDir(tile, trackdir, INVALID_OWNER, INVALID_RAILTYPES);
+		if (t == NULL) continue;
+		RailTypes rts = GetRailTypeInfo(t->railtype)->compatible_railtypes;
+		t = FindTrainForReservationDir(tile, trackdir, t->owner, rts);
+		/* Also verify that the train can actally use the start tile */
+		if (t != NULL && IsRailwayTileUsageAllowed(tile, t->owner) && HasBit(rts, GetTileRailType(tile))) {
+			return t;
 		}
-
-		/* Special case for bridges/tunnels: check the other end as well. */
-		if (IsTileType(ftoti.res.tile, MP_TUNNELBRIDGE)) {
-			FindVehicleOnPos(GetOtherTunnelBridgeEnd(ftoti.res.tile), &ftoti, FindTrainOnTrackEnum);
-			if (ftoti.best != NULL) return ftoti.best;
-		}
 	}
 
 	return NULL;
Index: src/signal.cpp
===================================================================
--- src/signal.cpp	(revision 17973)
+++ src/signal.cpp	(working copy)
@@ -16,6 +16,7 @@
 #include "vehicle_func.h"
 #include "functions.h"
 #include "train.h"
+#include "infrastructure_func.h"
 
 
 /** these are the maximums used for updating signal blocks */
@@ -278,7 +279,7 @@
 
 		switch (GetTileType(tile)) {
 			case MP_RAILWAY: {
-				if (GetTileOwner(tile) != owner) continue; // do not propagate signals on others' tiles (remove for tracksharing)
+				if (!AreSignalBlocksJoined(owner, GetTileOwner(tile))) continue; // check whether tile should be part of the same block, owner-wise
 
 				if (IsRailDepot(tile)) {
 					if (enterdir == INVALID_DIAGDIR) { // from 'inside' - train just entered or left the depot
@@ -351,7 +352,7 @@
 
 			case MP_STATION:
 				if (!HasStationRail(tile)) continue;
-				if (GetTileOwner(tile) != owner) continue;
+				if (!AreSignalBlocksJoined(owner, GetTileOwner(tile))) continue;
 				if (DiagDirToAxis(enterdir) != GetRailStationAxis(tile)) continue; // different axis
 				if (IsStationTileBlocked(tile)) continue; // 'eye-candy' station tile
 
@@ -361,7 +362,7 @@
 
 			case MP_ROAD:
 				if (!IsLevelCrossing(tile)) continue;
-				if (GetTileOwner(tile) != owner) continue;
+				if (!AreSignalBlocksJoined(owner, GetTileOwner(tile))) continue;
 				if (DiagDirToAxis(enterdir) == GetCrossingRoadAxis(tile)) continue; // different axis
 
 				if (!(flags & SF_TRAIN) && HasVehicleOnPos(tile, NULL, &TrainOnTileEnum)) flags |= SF_TRAIN;
@@ -369,7 +370,7 @@
 				break;
 
 			case MP_TUNNELBRIDGE: {
-				if (GetTileOwner(tile) != owner) continue;
+				if (!AreSignalBlocksJoined(owner, GetTileOwner(tile))) continue;
 				if (GetTunnelBridgeTransportType(tile) != TRANSPORT_RAIL) continue;
 				DiagDirection dir = GetTunnelBridgeDirection(tile);
 
Index: src/vehicle.cpp
===================================================================
--- src/vehicle.cpp	(revision 17973)
+++ src/vehicle.cpp	(working copy)
@@ -45,6 +45,7 @@
 #include "network/network.h"
 #include "core/pool_func.hpp"
 #include "economy_base.h"
+#include "infrastructure_func.h"
 
 #include "table/sprites.h"
 #include "table/strings.h"
@@ -1507,6 +1508,9 @@
 		case OT_LOADING: {
 			uint wait_time = max(this->current_order.wait_time - this->lateness_counter, 0);
 
+			/* Pay the loading fee when using someone else's station */
+			if (!(mode || this->type == VEH_TRAIN)) PayStationSharingFee(this, Station::Get(this->last_station_visited));
+
 			/* Not the first call for this tick, or still loading */
 			if (mode || !HasBit(this->vehicle_flags, VF_LOADING_FINISHED) ||
 					(_settings_game.order.timetabling && this->current_order_time < wait_time)) return;
Index: src/infrastructure.h
===================================================================
--- src/infrastructure.h	(revision 0)
+++ src/infrastructure.h	(revision 0)
@@ -0,0 +1,136 @@
+/* $Id$ */
+
+/*
+ * This file is part of OpenTTD.
+ * OpenTTD is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.
+ * OpenTTD is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with OpenTTD. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** @file infrastructure.h Define struct and enums for (shared) infrastructure */
+
+#ifndef INFRASTRUCTURE_H
+#define INFRASTRUCTURE_H
+
+#include "stdafx.h"
+#include "core/bitmath_func.hpp"
+#include "vehicle_type.h"
+#include "company_type.h"
+
+/** Sharing modes; possible values for the sharing_mode setting. */
+enum SharingMode {
+	SHARING_NONE,       ///< No infrastructure sharing at all
+	SHARING_GLOBAL,     ///< Sharing enabled with global (advanced) settings
+	SHARING_INDIVIDUAL, ///< Sharing enabled with individually configurable settings
+};
+
+/** flags for enabling / disabling various types of infrastructure */
+enum SharingOption {
+	SHARING_STATION = 1 << 0, ///< Stations are shared
+	SHARING_DEPOT   = 1 << 1, ///< Depots are shared
+	SHARING_TRACK   = 1 << 2, ///< Tracks are shared. (Trains only)
+};
+
+/** which part of the sharing settings do we want to modify? */
+enum ModifySharingFlag {
+	MODIFY_SHARING_OPTION,    ///< Modify access to station / depot / tracks
+	MODIFY_SHARING_FEE,       ///< Modify the sharing fee
+	MODIFY_SHARING_COMPANIES, ///< Modify which companies are allowed
+};
+
+/** maximum fee (in pounds) for any of the sharing fees */
+static const uint MAX_SHARING_FEE = 50000;
+
+/** number of relevant vehicle types */
+static const byte NUM_SHARING_VEHTYPES = 4;
+
+/** Bitmask of all relevant vehicle types. */
+static const byte ALL_SHARING_VEHTYPES = (1 << VEH_TRAIN) | (1 << VEH_ROAD) | (1 << VEH_SHIP) | (1 << VEH_AIRCRAFT);
+
+/** Struct to store all the sharing settings of a company (either current or future ones) */
+struct CompanySharingSettingsEntry {
+	byte option[NUM_SHARING_VEHTYPES]; ///< sharing options for rail/road/water/air
+	uint16 fee[NUM_SHARING_VEHTYPES];  ///< fees for rail/road/water/air
+	CompanyMask allowed_companies;     ///< which companies do we allow to use our infrastructure?
+
+	/** Constructor */
+	CompanySharingSettingsEntry() {}
+
+	/**
+	 * Compare two sets of sharing settings with eachother.
+	 * @param o The sharing settings entry to compare with.
+	 * @return True if all settings are equal, false otherwise.
+	 */
+	bool Equals(CompanySharingSettingsEntry *o);
+
+	/**
+	 * Copy the data of a specified sharing settings entry to this one.
+	 * @param o The sharing settings entry to use as source.
+	 * @return a bitmask of vehicle types whose permissions were reduced.
+	 */
+	byte Copy(CompanySharingSettingsEntry *o);
+
+	/**
+	 * Fill this struct with the values from _settings_game.
+	 * This also enables all companies in the allowed_companies mask.
+	 * @return a bitmask of vehicle types whose permissions were reduced.
+	 */
+	byte CopyFromGameSettings();
+
+	/**
+	 * Get the sharing option for a vehicle type.
+	 * @param type The vehicle type.
+	 * @return The sharing option for the specified vehicle type
+	 */
+	FORCEINLINE byte GetSharingOption(VehicleType type) const
+	{
+		assert(type < NUM_SHARING_VEHTYPES);
+		return this->option[type];
+	}
+
+	/**
+	 * Get the sharing fee for a specified vehicle type.
+	 * @param type The vehicle type.
+	 * @return The sharing fee for the given vehicle type.
+	 */
+	FORCEINLINE uint16 GetSharingFee(VehicleType type) const
+	{
+		assert(type < NUM_SHARING_VEHTYPES);
+		return this->fee[type];
+	}
+
+	/**
+	 * Set the sharing fee for a vehicle type.
+	 * @param type The vehicle type.
+	 * @param value The sharing option to set for the given vehicle type.
+	 */
+	FORCEINLINE void SetSharingOption(VehicleType type, byte value)
+	{
+		assert(type < NUM_SHARING_VEHTYPES);
+		this->option[type] = value;
+	}
+
+	/**
+	 * Set the sharing fee for a specified vehicle type.
+	 * @param type The vehicle type.
+	 * @param value The new sharing fee.
+	 */
+	FORCEINLINE void SetSharingFee(VehicleType type, uint16 value)
+	{
+		assert(type < NUM_SHARING_VEHTYPES);
+		this->fee[type] = value;
+	}
+
+	/**
+	 * Check whether a company is allowed to use the infrastructure.
+	 * i.e. it's corresponding bit in allowed_companies is set.
+	 * @param c The company to check.
+	 * @return true if the given company is allowed to use the infrastructure
+	 */
+	FORCEINLINE bool IsCompanyAllowed(CompanyID c) const
+	{
+		return HasBit(this->allowed_companies, c);
+	}
+};
+
+#endif /* INFRASTRUCTURE_H */
